##### redis优化
- 尽量使用ssd或者高性能磁盘，提高持久化到磁盘的效率
- 控制Redis实例最大可用内存，建议设置每实例内存为2G
- 不要让你的redis所在的机器物理内存使用超过实际内存总量的3/5
- 优先使用物理机或者高效支持fork操作的虚拟化技术
- 大数据量尽量按业务使用多个redis实例或集群把数据分散开
- 不要和其他CPU密集型服务部署在一起， 造成CPU过度竞争
- 不要和其他高硬盘负载的服务部署在一起
- 根据业务需要选择合适的数据类型，并为不同的应用场景设置相应的紧凑存储参数
- 当业务场景不需要数据持久化时，关闭所有的持久化方式可以获得最佳的性能以及最在的内存使用量
- key的命名尽量简短，键在存储中也消耗内存
- 如果有redis集群的，Master最好不要做任何持久化工作。如果数据比较关键，某个Slave开启AOF备份数据，策略为每秒同步一次。
- Redis主从复制的性能问题，为了主从复制的速度和连接的稳定性，Slave和Master最好在同一个局域网内