#### 备份
##### 自动备份
###### RDB
redis配置文件里默认是开启了RDB持久化的，符合下面的条件的会触发持久化到磁盘上（可以自定义）：
```
# 900秒（15分钟）内至少1个key值改变（则进行数据库保存--持久化） 
# 300秒（5分钟）内至少10个key值改变（则进行数据库保存--持久化） 
# 60秒（1分钟）内至少10000个key值改变（则进行数据库保存--持久化）
save 900 1
save 300 10
save 60 10000
```
###### AOF
redis配置文件里默认是开启了AOF持久化,如下：
`appendonly yes`

##### 手动备份
###### RDB
命令：
- save：redis save 命令执行一个同步保存操作，将当前 Redis 实例的所有数据快照(snapshot)以 RDB 文件的形式保存到硬盘
- bgsave：bgsave命令执行之后立即返回Background saving started，然后 redis fork 出一个新子进程，原来的 redis 进程(父进程)继续处理客户端请求，而子进程则负责将数据保存到磁盘，然后退出。返回成功执行的最后一次DB保存的UNIX TIME。客户端可以检查bgsave命令是否成功读取LASTSAVE值，然后发出bgsave命令，并且如果lastsave改变则每隔N秒定期检查一次。

区别：
- save保存是阻塞主进程，客户端无法连接redis，等SAVE完成后，主进程才开始工作，客户端可以连接
- bgsave是fork一个save的子进程，在执行save过程中，不影响主进程，客户端可以正常链接redis，等子进程fork执行save完成后，通知主进程，子进程关闭。很明显BGSAVE方式比较适合线上的维护操作。

###### AOF
命令：
- bgrewriteaof

#### 恢复
- 如果是redis机器或进程挂掉，假如已经开启了AOF持久化，那么重启机器/进程，redis会直接基于AOF日志文件恢复数据
- 如果redis当前最新的AOF和RDB文件出现了丢失/损坏，那么可以尝试基于该机器上当前的某个最新的RDB数据副本进行数据恢复
1、停止redis(命令是redis-cli shutdown),
2、在配置文件中关闭aof: appendonly no
3、拷贝rdb日志备份到redis的数据目录下
4、启动redis，在没有AOF的文件下，redis会自动读取RDB文件恢复数据
5、尝试get一个key,确认数据恢复

#### 迁移工具

##### redis-migrate-tool
github地址：[https://github.com/vipshop/redis-migrate-tool](https://github.com/vipshop/redis-migrate-tool "https://github.com/vipshop/redis-migrate-tool")

简介：redis-migrate-tool是一种方便有用的工具，用于在redis之间迁移数据。

特征：
- 快速。
- 多线程。
- 基于redis复制。
- 实时迁移。
- 在迁移数据的过程中，源redis还可以为用户提供服务。
- 异构迁移。
- Twemproxy和redis集群支持。
- 当目标是twemproxy时，键被直接导入到twemproxy后面的redis中。
- 迁移状态视图。
- 数据验证机制。

基础环境：服务器：192.168.37.11
系统版本：centos7.6

安装依赖：`yum -y install automake libtool autoconf bzip2 unzip`

安装软件：
```
[root@test11 redis-5.0.5]# wget https://github.com/vipshop/redis-migrate-tool/archive/master.zip
[root@test11 redis-5.0.5]# unzip master.zip
[root@test11 redis-5.0.5]# cd redis-migrate-tool-master/
[root@test11 redis-migrate-tool-master]# autoreconf -fvi
[root@test11 redis-migrate-tool-master]# ./configure
[root@test11 redis-migrate-tool-master]# make
[root@test11 redis-migrate-tool-master]# ./src/redis-migrate-tool -h
```
实例：从集群到集群迁移，编辑rmt.conf进行迁移，如下：
```
[root@test11 redis-migrate-tool-master]# cat rmt.conf 
[source]
type: redis cluster
servers : 
  - 192.168.37.11:7001

[target]
type: redis cluster
servers:
  - 192.168.37.11:7007

[common]
listen: 0.0.0.0:8888
```
执行同步：`[root@test11 redis-migrate-tool-master]# ./src/redis-migrate-tool -c rmt.conf -o log -d`

一致性效验：`[root@test11 redis-migrate-tool-master]# ./src/redis-migrate-tool -c rmt.conf -o log -C redis_check`

插入数据效验：`[root@test11 redis-migrate-tool-master]# ./src/redis-migrate-tool -c rmt.conf -o log -C redis_testinsert`

注意了：redis5.0版本会报错，查看生成的日志：`cat log`，报错如下：
```
[2019-07-19 14:31:53.548] rmt_redis.c:6446 ERROR: Can't handle RDB format version -905891832
[2019-07-19 14:31:53.548] rmt_redis.c:6715 ERROR: Rdb file for node[192.168.37.11:7004@17004] parsed failed
```
原因是redis-migrate-tool-master这个工具最后一次更新是2017年，应该是不支持redis5.0的新格式，期待作者更新！所以redis5.0建议还是采用冷迁移。redis3.x是可以迁移成功的。